<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="所属部门" prop="deptId">
          <treeselect style="width:205.4px" v-model="queryParams.deptId" :options="deptOptions" :show-count="true" placeholder="请选择所属部门" />
      </el-form-item>
      <el-form-item label="客户编号" prop="customerCode">
        <el-input
        style="width:220px"
          v-model="queryParams.customerCode"
          placeholder="请输入客户编号"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="员工姓名" prop="companyUserNickName">
        <el-input
        style="width:220px"
          v-model="queryParams.companyUserNickName"
          placeholder="请输入员工姓名"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="手机号" prop="phone">
        <el-input
        style="width:220px"
          v-model="queryParams.phone"
          placeholder="请输入发送手机号"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="提交时间" prop="createTime">
          <el-date-picker
            style="width:220px"
            clearable size="small"
            v-model="dateRange"
            type="daterange"
            value-format="yyyy-MM-dd"
            start-placeholder="开始日期"
            end-placeholder="结束日期">
          </el-date-picker>
      </el-form-item>
      <el-form-item label="是否回复" prop="isReply">
        <el-select style="width:220px" v-model="queryParams.isReply" placeholder="请选择是否回复" clearable size="small">
              <el-option :key="1" label="是" :value="1"/>
              <el-option :key="0" label="否" :value="0"/>
        </el-select>
      </el-form-item>
      <el-form-item label="状态" prop="status">
        <el-select style="width:220px" v-model="queryParams.status" placeholder="请选择状态" clearable size="small">
              <el-option
                v-for="dict in statusOptions"
                :key="dict.dictValue"
                :label="dict.dictLabel"
                :value="dict.dictValue"
              />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="cyan" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>
    <el-row :gutter="10" class="mb8">
      
      <el-col :span="1.5">
        <el-button
          type="warning"
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['company:companySmsLogs:export']"
        >导出</el-button>
      </el-col>
	  <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table height="500" border v-loading="loading" :data="companySmsLogsList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="ID" align="center" prop="logsId" />
      <el-table-column label="客户编码" align="center" prop="customerCode" />
      <el-table-column  label="客户名称"   align="center" prop="customerName" :show-overflow-tooltip="true">
        <template slot-scope="scope">
          <el-link @click="handleShow(scope.row)" :underline="false" type="primary" >{{scope.row.customerName}}</el-link>
        </template>
      </el-table-column>
      <el-table-column label="手机号" align="center" prop="phone" />
      <el-table-column label="短信内容" show-overflow-tooltip align="center" prop="content" />
      <el-table-column label="发送者" align="center" prop="companyUserNickName" />
      <el-table-column label="提交时间" align="center" prop="createTime" width="180">
      </el-table-column>
      <el-table-column label="发送时间" align="center" prop="sendTime" width="180">
      </el-table-column>
      <el-table-column label="状态" align="center" prop="status" >
        <template slot-scope="scope">
              <el-tag prop="status" v-for="(item, index) in statusOptions"  :type="scope.row.status==1?'success':'danger'"  v-if="scope.row.status==item.dictValue">{{item.dictLabel}}</el-tag>
        </template>
      </el-table-column>
      <el-table-column label="回复内容" align="center" prop="replyContent" />
      
    </el-table>
    
    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <el-drawer
      size="75%"
      :title="show.title" :visible.sync="show.open"
      >
        <customer-details  ref="customerDetails" />
    </el-drawer>
  </div>
</template>

<script>
import { listCompanySmsLogs, getCompanySmsLogs, delCompanySmsLogs, addCompanySmsLogs, updateCompanySmsLogs, exportCompanySmsLogs } from "@/api/company/companySmsLogs";
import Editor from '@/components/Editor';
import customerDetails from '../../crm/components/customerDetails.vue';
import { treeselect } from "@/api/company/companyDept";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";

export default {
  name: "CompanySmsLogs",
  components: { customerDetails,Editor,Treeselect },
  data() {
    return {
      // 部门树选项
      deptOptions: undefined,
      // 部门名称
      deptName: undefined,
      show:{
        title:"客户详情",
        open:false,
      },
      statusOptions:[],
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      dateRange:[],
      // 短信发送记录表格数据
      companySmsLogsList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        companyId: null,
        userId: null,
        customerId: null,
        tempId: null,
        tempCode: null,
        phone: null,
        content: null,
        sendTime: null,
        status: null,
        isReply:null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  created() {
    this.getDicts("company_sms_logs_status").then((response) => {
      this.statusOptions = response.data;
    });
    this.getList();
    this.getTreeselect();
  },
  methods: {
    handleShow(row){
      var that=this;
      that.show.open=true;
      setTimeout(() => {
          that.$refs.customerDetails.getDetails(row.customerId);
      }, 200);
    },
    /** 查询短信发送记录列表 */
    getList() {
      this.loading = true;
      listCompanySmsLogs(this.addDateRange(this.queryParams, this.dateRange)).then(response => {
        this.companySmsLogsList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        logsId: null,
        companyId: null,
        userId: null,
        customerId: null,
        tempId: null,
        tempCode: null,
        phone: null,
        content: null,
        createTime: null,
        sendTime: null,
        status: 0
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.logsId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加短信发送记录";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const logsId = row.logsId || this.ids
      getCompanySmsLogs(logsId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改短信发送记录";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.logsId != null) {
            updateCompanySmsLogs(this.form).then(response => {
              if (response.code === 200) {
                this.msgSuccess("修改成功");
                this.open = false;
                this.getList();
              }
            });
          } else {
            addCompanySmsLogs(this.form).then(response => {
              if (response.code === 200) {
                this.msgSuccess("新增成功");
                this.open = false;
                this.getList();
              }
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const logsIds = row.logsId || this.ids;
      this.$confirm('是否确认删除短信发送记录编号为"' + logsIds + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delCompanySmsLogs(logsIds);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(function() {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有短信发送记录数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return exportCompanySmsLogs(queryParams);
        }).then(response => {
          this.download(response.msg);
        }).catch(function() {});
    },
    getTreeselect() {
      treeselect().then((response) => {
        this.deptOptions = response.data;
      });
    }, 

  }
};
</script>
